/**
 * Npcf_SMPolicyControl API
 * Session Management Policy Control Service © 2020, 3GPP Organizational
 * Partners (ARIB, ATIS, CCSA, ETSI, TSDSI, TTA, TTC). All rights reserved.
 *
 * The version of the OpenAPI document: 1.1.1.alpha-5
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator
 * (https://openapi-generator.tech). https://openapi-generator.tech Do not edit
 * the class manually.
 */
/*
 * RedirectInformation.h
 *
 *
 */

#ifndef RedirectInformation_H_
#define RedirectInformation_H_

#include <string>
#include "RedirectAddressType.h"
#include <nlohmann/json.hpp>

namespace oai {
namespace smf_server {
namespace model {

/// <summary>
///
/// </summary>
class RedirectInformation {
 public:
  RedirectInformation();
  virtual ~RedirectInformation() = default;

  /// <summary>
  /// Validate the current data in the model. Throws a ValidationException on
  /// failure.
  /// </summary>
  void validate() const;

  /// <summary>
  /// Validate the current data in the model. Returns false on error and writes
  /// an error message into the given stringstream.
  /// </summary>
  bool validate(std::stringstream& msg) const;

  /// <summary>
  /// Helper overload for validate. Used when one model stores another model and
  /// calls it's validate. Not meant to be called outside that case.
  /// </summary>
  bool validate(std::stringstream& msg, const std::string& pathPrefix) const;

  bool operator==(const RedirectInformation& rhs) const;
  bool operator!=(const RedirectInformation& rhs) const;

  /////////////////////////////////////////////
  /// RedirectInformation members

  /// <summary>
  /// Indicates the redirect is enable.
  /// </summary>
  bool isRedirectEnabled() const;
  void setRedirectEnabled(bool const value);
  bool redirectEnabledIsSet() const;
  void unsetRedirectEnabled();
  /// <summary>
  ///
  /// </summary>
  RedirectAddressType getRedirectAddressType() const;
  void setRedirectAddressType(RedirectAddressType const& value);
  bool redirectAddressTypeIsSet() const;
  void unsetRedirectAddressType();
  /// <summary>
  /// Indicates the address of the redirect server.
  /// </summary>
  std::string getRedirectServerAddress() const;
  void setRedirectServerAddress(std::string const& value);
  bool redirectServerAddressIsSet() const;
  void unsetRedirectServerAddress();

  friend void to_json(nlohmann::json& j, const RedirectInformation& o);
  friend void from_json(const nlohmann::json& j, RedirectInformation& o);

 protected:
  bool m_RedirectEnabled;
  bool m_RedirectEnabledIsSet;
  RedirectAddressType m_RedirectAddressType;
  bool m_RedirectAddressTypeIsSet;
  std::string m_RedirectServerAddress;
  bool m_RedirectServerAddressIsSet;
};

}  // namespace model
}  // namespace smf_server
}  // namespace oai
#endif /* RedirectInformation_H_ */
